#include	"18b20.h"

void	ds18_StartIzm(long long llAdr)
{
//  llAdr=0;
W1Reset();
if(!llAdr)
	{					//  
	W1SendCommand(DS18_SKIP);
	}
else
	{
	W1SendCommand(DS18_EQU);
	W1SendAdr(llAdr);
	}
W1SendCommand(DS18_START);
}

int	ds18_GetRAM(long long llAdr,ds18MemStruct *sDat)
{
unsigned char CRC=0;  
  
W1Reset();
if(!llAdr)
	{					//  
	W1SendCommand(DS18_SKIP);
	}
else
	{
	W1SendCommand(DS18_EQU);
	W1SendAdr(llAdr);
	}
W1SendCommand(DS18_READ);
sDat->cTL=W1GetByte();
sDat->cTM=W1GetByte();
sDat->cTHR=W1GetByte();
sDat->cTLR=W1GetByte();
sDat->cC=W1GetByte();
sDat->cR1=W1GetByte();
sDat->cR2=W1GetByte();
sDat->cR3=W1GetByte();
sDat->CRC=W1GetByte();

W1CalkCRCByte(sDat->cTL,&CRC);
W1CalkCRCByte(sDat->cTM,&CRC);
W1CalkCRCByte(sDat->cTHR,&CRC);
W1CalkCRCByte(sDat->cTLR,&CRC);
W1CalkCRCByte(sDat->cC,&CRC);
W1CalkCRCByte(sDat->cR1,&CRC);
W1CalkCRCByte(sDat->cR2,&CRC);
W1CalkCRCByte(sDat->cR3,&CRC);

return CRC==sDat->CRC?0:-1;
}

float	ds18_Temp(ds18MemStruct *sDat)
{
int	iT;
float	f;

//iT=(((int)sDat->cTM)<<8)|sDat->cTL;
iT=sDat->cTM;
iT<<=8;
iT|=(unsigned char)sDat->cTL;
f=((float)iT)/16.;

return f;  
}
