#include "1ware.h"

#ifndef	__18B20__
#define	__18B20__

#define	DS18_SKIP	0xCC
#define	DS18_START	0x44
#define	DS18_EQU	0x55
#define	DS18_READ	0xBE		//33

typedef struct	ds18MemStruct_
{
  signed char cTL;
  signed char cTM;
  signed char cTHR;
  signed char cTLR;
  signed char cC;
  signed char cR1;
  signed char cR2;
  signed char cR3;
  unsigned char CRC;  
} ds18MemStruct;

void	ds18_StartIzm(long long llAdr);
int	ds18_GetRAM(long long llAdr,ds18MemStruct *sDat);
float	ds18_Temp(ds18MemStruct *sDat);
#endif
