#include "d_44780.h"
#include "serv.h"

#define	STROB_D	10


/* [0] "" */
const unsigned char Init2[]={32,32,80,97,183,112,97,178,111,191,97,187,0};

/* [0] "." */
const unsigned char Init3[]={32,32,65,46,164,121,185,186,111,179,0};


void	Ind_Strob(void)
{
  delay_us(STROB_D);
  D_E_SET;
  delay_us(STROB_D);
  D_E_CLR;
  delay_us(STROB_D);
}

unsigned char Ind_RDCom8(void)
{      
unsigned char tmp=0;

D_RW_SET;		// RW - !
D_RS_CLR;		// RS - !
delay_us(STROB_D);
D_E_SET;		//E
delay_us(STROB_D);
if(D_DB3_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB2_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB1_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB0_PIN)
	tmp|=1;
D_E_CLR;		//E
D_RW_CLR;		// RW - !
return tmp;
}

void    Ind_WRCom8(unsigned char c)
{                            
D_RW_CLR;		// RW - !
D_RS_CLR;		// RS - !
delay_us(STROB_D);

D_DB3_DIR=1;		//   
D_DB2_DIR=1;
D_DB1_DIR=1;
D_DB0_DIR=1;

if(c&0x80)
	D_DB3_SET;
else
	D_DB3_CLR;
if(c&0x40)
	D_DB2_SET;
else
	D_DB2_CLR;
if(c&0x20)
	D_DB1_SET;
else
	D_DB1_CLR;
if(c&0x10)
	D_DB0_SET;
else
	D_DB0_CLR;

delay_us(STROB_D);
D_E_SET;
delay_us(STROB_D);
D_E_CLR;
delay_us(STROB_D);
D_DB3_DIR=0;		//   
D_DB2_DIR=0;
D_DB1_DIR=0;
D_DB0_DIR=0;

D_DB0_CLR;
D_DB1_CLR;
D_DB2_CLR;
D_DB3_CLR;

//PORTA=0;
}

unsigned char Ind_RDCom4(void)
{
unsigned char tmp=0;

D_RW_SET;		// RW - !
D_RS_CLR;		// RS - !
delay_us(STROB_D);
D_E_SET;
delay_us(STROB_D);

if(D_DB3_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB2_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB1_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB0_PIN)
	tmp|=1;
tmp<<=1;
D_E_CLR;
delay_us(STROB_D);
D_E_SET;
delay_us(STROB_D);
if(D_DB3_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB2_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB1_PIN)
	tmp|=1;
tmp<<=1;
if(D_DB0_PIN)
	tmp|=1;
D_E_CLR;
D_RW_CLR;		// RW - !

return tmp;
}

void    Ind_WhiteBisy(void)
{
while(1)
        {
        if(!(Ind_RDCom4()&0x80))
                break;
        }
}

void    Ind_WR4(unsigned char cKom,unsigned char c)
{                                           

Ind_WhiteBisy();
if(cKom)                                ///
        {
	D_RS_CLR;		// RS - !
        }

else    
        {
	D_RS_SET;		// RS - !
        }
D_RW_CLR;		// RW - !
D_DB3_DIR=1;		//   
D_DB2_DIR=1;
D_DB1_DIR=1;
D_DB0_DIR=1;

if(c&0x80)
	D_DB3_SET;
else
	D_DB3_CLR;
if(c&0x40)
	D_DB2_SET;
else
	D_DB2_CLR;
if(c&0x20)
	D_DB1_SET;
else
	D_DB1_CLR;
if(c&0x10)
	D_DB0_SET;
else
	D_DB0_CLR;
delay_us(STROB_D);
D_E_SET;
delay_us(STROB_D);
D_E_CLR;
delay_us(STROB_D);

if(c&0x8)
	D_DB3_SET;
else
	D_DB3_CLR;
if(c&0x4)
	D_DB2_SET;
else
	D_DB2_CLR;
if(c&0x2)
	D_DB1_SET;
else
	D_DB1_CLR;
if(c&0x1)
	D_DB0_SET;
else
	D_DB0_CLR;
delay_us(STROB_D);
D_E_SET;
delay_us(STROB_D);
D_E_CLR;
                                         
D_DB3_DIR=0;		//   
D_DB2_DIR=0;
D_DB1_DIR=0;
D_DB0_DIR=0;
//RTA=0x0;
}

void	IndString(unsigned char *pStr,unsigned char ucPos,unsigned char ucNStr)
{
if(ucNStr)
	Ind_WR4(1,ucPos+0xC0);
else
	Ind_WR4(1,ucPos+0x80);
while(*pStr)
        {         
        Ind_WR4(0,*pStr);
        pStr++;
        }
}

void    IndInit(void)
{
D_RW_DIR=1;  
D_RS_DIR=1;  
D_E_DIR=1;  
delay_ms(21);
Ind_WRCom8(0x30);
delay_ms(5);
Ind_WRCom8(0x30);
delay_us(6000);
Ind_WRCom8(0x30); 
while(1)
        {
        if(!(Ind_RDCom8()&0x8))
                break;
        ;
        }   
Ind_WRCom8(0x20);   // 4-  ;
Ind_WR4(1,0x28);    //2 , 4 
Ind_WR4(1,0x0c);    //                         
Ind_WR4(1,0x06);    //   


IndString((unsigned char*)Init2,0,0);
IndString((unsigned char*)Init3,0,1);
}

