#include <iolpc2124.h>
#include <inarm.h>

#ifndef	__INIT__
#define	__INIT__


#define	F_OSC	12000000		// 
#define K_PLL	5			//  (PLLCFG_bit.MSEL=4)		
#define	CCLK	(F_OSC*K_PLL)		//  
#define	PCLK	(CCLK/4)		//VPBDIV_bit.VPBDIV=0
#define	PLOCK	0x400			// 

//FCCO=CCLK*2*P=156...320M, P=2, PLLCFG_bit.PSEL=P-1=1



void PRCInit(void);
void PRC_Init_T0(void);
void PRC_Init_MAM(void);
void PRC_Init_PLL(void);
void PRC_Init_VIC(void);

#endif
