#include "my_uart.h"

void U0Init(void)
{
U0_PINSEL_TX_SET;		//   UART
U0_PINSEL_RX_SET;
U0LCR_bit.DLAB=1;		//  
U0DLL=PCLK/(16*BAUD_RATE0);	//  
U0DLM=(PCLK/(16*BAUD_RATE0))>>8;
U0LCR_bit.DLAB=0;		//   
U0LCR_bit.WLS=3;		//8 
U0LCR_bit.SBS=0;		//1 
U0FCR_bit.RTLS=0;
U0FCR_bit.FCRFE=1;		//(RTLS=0)1  
U0FCR_bit.RFR=1;		//  
U0FCR_bit.TFR=1;		//  
U0IER=0;			// 
}

void U1Init(void)
{
U1_PINSEL_TX_SET;		//   UART
U1_PINSEL_RX_SET;
U1MCR=0;
U1LCR_bit.DLAB=1;		//  
U1DLL=PCLK/(16*BAUD_RATE1);	//  
U1DLM=(PCLK/(16*BAUD_RATE1))>>8;
U1LCR_bit.DLAB=0;		//   
U1LCR_bit.WLS=3;		//8 
U1LCR_bit.SBS=0;		//1 
U1FCR_bit.RTLS=0;
U1FCR_bit.FCRFE=1;		//(RTLS=0)1  
U1FCR_bit.RFR=1;		//  
U1FCR_bit.TFR=1;		//  
U1IER=0;			// 
}

int	U0Send(unsigned char b)
{
if(!U0LSR_bit.THRE)
	return -1;
U0THR=b;
return 0;
}

int	U1Send(unsigned char b)
{
if(!U1LSR_bit.THRE)
	return -1;
U1THR=b;
return 0;
}

int	U0Rec(unsigned char *b)
{
if(!U0LSR_bit.DR)
	return -1;
*b=U0RBR;
return 0;
}

int	U1Rec(unsigned char *b)
{
if(!U1LSR_bit.DR)
	return -1;
*b=U1RBR;
return 0;
}
